#ifndef NAMED_COUNTER__INCLUDED
#define NAMED_COUNTER__INCLUDED

#include "RefCount.h"

#include <string>

class NamedCounterImpl :
   public virtual POA_NamedCounter,
	public virtual PortableServer::ServantBase
{
   public :
      
      NamedCounterImpl(
         const std::string &name, 
         const CORBA::Long initialValue,
         PortableServer::POA_var poa);

      ~NamedCounterImpl();

      // implement the interface

      virtual char* name();
      virtual CORBA::Long value();
      virtual void value(CORBA::Long);
      
   private :

      const std::string m_name;
      CORBA::Long m_value;
      PortableServer::POA_var m_poa;
      PortableServer::ObjectId_var m_objectID;
};

#endif NAMED_COUNTER_FACTORY__INCLUDED